/*******************************************************************************
 * ProcBuilding generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class ProcBuilding extends Volume
    native(ProcBuilding)
    placeable
    hidecategories(Navigation,Object,Movement,Display);

const ROOF_MINZ = 0.7;
const PROCBUILDING_VERSION = 1;

enum EScopeEdge
{
    EPSA_Top,
    EPSA_Bottom,
    EPSA_Left,
    EPSA_Right,
    EPSA_None,
    EPSA_MAX
};

enum EPBCornerType
{
    EPBC_Default,
    EPBC_Chamfer,
    EPBC_Round,
    EPBC_MAX
};

enum EBuildingStatsBrowserColumns
{
    BSBC_Name,
    BSBC_Ruleset,
    BSBC_NumStaticMeshComps,
    BSBC_NumInstancedStaticMeshComps,
    BSBC_NumInstancedTris,
    BSBC_LightmapMemBytes,
    BSBC_ShadowmapMemBytes,
    BSBC_LODDiffuseMemBytes,
    BSBC_LODLightingMemBytes,
    BSBC_MAX
};

struct native PBScope2D
{
    var Matrix ScopeFrame;
    var float DimX;
    var float DimZ;

    structdefaultproperties
    {
        ScopeFrame=(XPlane=(X=0.0,Y=0.0,Z=0.0,W=0.0),YPlane=(X=0.0,Y=0.0,Z=0.0,W=0.0),ZPlane=(X=0.0,Y=0.0,Z=0.0,W=0.0),WPlane=(X=0.0,Y=0.0,Z=0.0,W=0.0))
        DimX=0.0
        DimZ=0.0
    }
};

struct native PBScopeProcessInfo
{
    var ProcBuilding OwningBuilding;
    var ProcBuildingRuleset Ruleset;
    var name RulesetVariation;
    var bool bGenerateLODPoly;
    var bool bPartOfNonRect;

    structdefaultproperties
    {
        OwningBuilding=none
        Ruleset=none
        RulesetVariation=None
        bGenerateLODPoly=false
        bPartOfNonRect=false
    }
};

struct native PBFaceUVInfo
{
    var Vector2D Offset;
    var Vector2D Size;

    structdefaultproperties
    {
        Offset=(X=0.0,Y=0.0)
        Size=(X=0.0,Y=0.0)
    }
};

struct native PBEdgeInfo
{
    var Vector EdgeEnd;
    var Vector EdgeStart;
    var int ScopeAIndex;
    var ProcBuilding.EScopeEdge ScopeAEdge;
    var int ScopeBIndex;
    var ProcBuilding.EScopeEdge ScopeBEdge;
    var float EdgeAngle;

    structdefaultproperties
    {
        EdgeEnd=(X=0.0,Y=0.0,Z=0.0)
        EdgeStart=(X=0.0,Y=0.0,Z=0.0)
        ScopeAIndex=0
        ScopeAEdge=EScopeEdge.EPSA_Top
        ScopeBIndex=0
        ScopeBEdge=EScopeEdge.EPSA_Top
        EdgeAngle=0.0
    }
};

struct native PBMeshCompInfo
{
    var export editinline StaticMeshComponent MeshComp;
    var int TopLevelScopeIndex;

    structdefaultproperties
    {
        MeshComp=none
        TopLevelScopeIndex=0
    }
};

struct native PBFracMeshCompInfo
{
    var export editinline FracturedStaticMeshComponent FracMeshComp;
    var int TopLevelScopeIndex;

    structdefaultproperties
    {
        FracMeshComp=none
        TopLevelScopeIndex=0
    }
};

struct native PBMaterialParam
{
    var() name ParamName;
    var() LinearColor Color;

    structdefaultproperties
    {
        ParamName=None
        Color=(R=0.0,G=0.0,B=0.0,A=1.0)
    }
};

struct native PBMemUsageInfo
{
    var ProcBuilding Building;
    var ProcBuildingRuleset Ruleset;
    var int NumStaticMeshComponent;
    var int NumInstancedStaticMeshComponents;
    var int NumInstancedTris;
    var int LightmapMemBytes;
    var int ShadowmapMemBytes;
    var int LODDiffuseMemBytes;
    var int LODLightingMemBytes;

    structdefaultproperties
    {
        Building=none
        Ruleset=none
        NumStaticMeshComponent=0
        NumInstancedStaticMeshComponents=0
        NumInstancedTris=0
        LightmapMemBytes=0
        ShadowmapMemBytes=0
        LODDiffuseMemBytes=0
        LODLightingMemBytes=0
    }
};

var() editoronly ProcBuildingRuleset Ruleset;
var() const editconst array<editconst PBMeshCompInfo> BuildingMeshCompInfos;
var() const editconst array<editconst PBFracMeshCompInfo> BuildingFracMeshCompInfos;
var() const editconst export editinline StaticMeshComponent SimpleMeshComp;
var() bool bGenerateRoofMesh;
var() bool bGenerateFloorMesh;
var() bool bApplyRulesToRoof;
var() bool bApplyRulesToFloor;
var() bool bSplitWallsAtRoofLevels;
var() bool bSplitWallsAtWallEdges;
var transient bool bQuickEdited;
var() bool bBuildingBrushCollision;
var(Debug) bool bDebugDrawEdgeInfo;
var(Debug) bool bDebugDrawScopes;
var const export editinline array<export editinline StaticMeshComponent> LODMeshComps;
var editoronly array<editoronly PBFaceUVInfo> LODMeshUVInfos;
var editoronly array<editoronly PBScope2D> TopLevelScopes;
var int NumMeshedTopLevelScopes;
var editoronly array<editoronly PBFaceUVInfo> TopLevelScopeUVInfos;
var editoronly array<editoronly PBScopeProcessInfo> TopLevelScopeInfos;
var editoronly array<editoronly PBEdgeInfo> EdgeInfos;
var float MaxFacadeZ;
var float MinFacadeZ;
var transient array<ProcBuilding> OverlappingBuildings;
var() float SimpleMeshMassiveLODDistance;
var() float RenderToTexturePullBackAmount;
var() int RoofLightmapRes;
var() int NonRectWallLightmapRes;
var() editoronly float LODRenderToTextureScale;
var() name ParamSwatchName;
var() array<PBMaterialParam> BuildingMaterialParams;
var editoronly array<editoronly MaterialInstanceConstant> BuildingMatParamMICs;
var() duplicatetransient crosslevelpassive const editconst StaticMeshActor LowLODPersistentActor;
var export editinline transient StaticMeshComponent CurrentSimpleMeshComp;
var transient Actor CurrentSimpleMeshActor;
var editoronly array<editoronly ProcBuilding> AttachedBuildings;
var const int BuildingInstanceVersion;

// Export UProcBuilding::execClearBuildingMeshes(FFrame&, void* const)
native function ClearBuildingMeshes();

// Export UProcBuilding::execFindComponentsForTopLevelScope(FFrame&, void* const)
native function array<editinline StaticMeshComponent> FindComponentsForTopLevelScope(int TopLevelScopeIndex);

// Export UProcBuilding::execGetBaseMostBuilding(FFrame&, void* const)
native function ProcBuilding GetBaseMostBuilding();

// Export UProcBuilding::execGetAllGroupedProcBuildings(FFrame&, void* const)
native function GetAllGroupedProcBuildings(out array<ProcBuilding> OutSet);

// Export UProcBuilding::execBreakFractureComponent(FFrame&, void* const)
native function BreakFractureComponent(FracturedStaticMeshComponent Comp, Vector BoxMin, Vector BoxMax);

// Export UProcBuilding::execFindEdgeForTopLevelScope(FFrame&, void* const)
native function int FindEdgeForTopLevelScope(int TopLevelScopeIndex, ProcBuilding.EScopeEdge Edge);

defaultproperties
{
    bGenerateRoofMesh=true
    bSplitWallsAtRoofLevels=true
    bSplitWallsAtWallEdges=true
    bBuildingBrushCollision=true
    SimpleMeshMassiveLODDistance=10000.0
    RenderToTexturePullBackAmount=125.0
    RoofLightmapRes=64
    NonRectWallLightmapRes=64
    LowLODPersistentActor=none
    BrushColor=(R=222,G=255,B=135,A=255)
    bColored=true
    begin object name=BrushComponent0 class=BrushComponent
        ReplacementPrimitive=none
        RBChannel=ERBCollisionChannel.RBCC_BlockingVolume
        BlockActors=true
        BlockRigidBody=true
        bDisableAllRigidBody=false
    object end
    // Reference: BrushComponent'Default__ProcBuilding.BrushComponent0'
    BrushComponent=BrushComponent0
    begin object name=BrushComponent0 class=BrushComponent
        ReplacementPrimitive=none
        RBChannel=ERBCollisionChannel.RBCC_BlockingVolume
        BlockActors=true
        BlockRigidBody=true
        bDisableAllRigidBody=false
    object end
    // Reference: BrushComponent'Default__ProcBuilding.BrushComponent0'
    Components(0)=BrushComponent0
    bHidden=false
    bWorldGeometry=true
    bRouteBeginPlayEvenIfStatic=false
    bGameRelevant=true
    bMovable=false
    bBlockActors=true
    bForceOctreeSNFilter=true
    bPathColliding=true
    begin object name=BrushComponent0 class=BrushComponent
        ReplacementPrimitive=none
        RBChannel=ERBCollisionChannel.RBCC_BlockingVolume
        BlockActors=true
        BlockRigidBody=true
        bDisableAllRigidBody=false
    object end
    // Reference: BrushComponent'Default__ProcBuilding.BrushComponent0'
    CollisionComponent=BrushComponent0
}